﻿Module modDISK2NOL

	Sub Main()
		Dim COT, ZAST, DISK, PAPKA, FAIL, VREM, IMAS, TXT, MAS(1024) As String
		Dim MESTO, I, S, L, N, M, H As Long
		Dim PROC, STRO, STOL As Integer
		Dim C As System.IO.DriveInfo
		Dim SCROL As Boolean
		ZAST = "'disk2nol', version 2" + vbCrLf + "Designed by Erich H. Hauser," + vbCrLf + "'www.erichware.com', Baku, 25.02.24" + vbCrLf
		PAPKA = "DIR-DISK2NOL-TMP.TMP"
		FAIL = "FIL-DISK2NOL-TMP.TMP"
		S = 1048576 : L = 4096
		COT = Command$()
		On Error Resume Next
		Console.Clear() : Console.Write(ZAST)
		If Len(COT) < 2 Then
			TXT = "Usage:" + vbCrLf + "1. To remove traces of old information on the hard disk:" + vbCrLf + "...\current dir>disk2nol.exe diskletter:" + vbCrLf + "(example: 'c:', 'd:', etc)" + vbCrLf
			TXT = TXT + "2. To permanently delete the contents of a file(s):" + vbCrLf + "...\current dir>disk2nol.exe filename|mask" + vbCrLf + "(Without path! Only in current directory)"
			GoTo KON
		End If
		If Mid$(COT, 2, 1) = ":" Then
			DISK = Left$(COT$, 1) + ":\" : PAPKA = DISK + PAPKA : MkDir(PAPKA)
			If Err.Number > 0 Then TXT = "Disk i/o error" : GoTo KON
			FAIL = PAPKA + "\" + FAIL
			C = My.Computer.FileSystem.GetDriveInfo(DISK)
			FileOpen(1, FAIL, OpenMode.Binary)
			If Err.Number > 0 Then TXT = "File i/o error" : GoTo KON
			Console.Write(vbCrLf + "For interrupt use 'ScrollLock' mode" + vbCrLf)
			TXT = "Canceled" : STRO = Console.CursorTop : STOL = Console.CursorLeft
			MESTO = C.TotalFreeSpace : N = MESTO \ S
			VREM = Space$(S) : Console.CursorTop = STRO
			For I = 1 To N
				FilePut(1, VREM) : If (My.Computer.Keyboard.ScrollLock) Then GoTo VSE
				PROC = CInt(100.0! * I / N) : Console.CursorLeft = STOL : Console.Write(CStr(PROC) + "%")
			Next I
			MESTO = C.TotalFreeSpace : M = MESTO \ L
			VREM = Space$(L) : Console.CursorTop = STRO + 1
			For I = 1 To M
				FilePut(1, VREM) : If (My.Computer.Keyboard.ScrollLock) Then GoTo VSE
				PROC = CInt(100.0! * I / M) : Console.CursorLeft = STOL : Console.Write(CStr(PROC) + "%")
			Next I
VSE:
			FileClose(1)
			Kill(FAIL) : If Err.Number > 0 Then TXT = "Can't delete file" : GoTo KON
			RmDir(PAPKA) : If Err.Number > 0 Then TXT = "Can't delete folder" : GoTo KON
			TXT = "Complete"
		Else
			H = 0 : IMAS = Dir(COT, 0) : If IMAS = "" Then TXT = "File not found" : GoTo KON
			While IMAS <> ""
				H = H + 1 : MAS(H) = IMAS : IMAS = Dir()
			End While
			S = 16777216 : Console.Write(vbCrLf + "	Files:" + vbCrLf)
			For I = 1 To H
				IMAS = MAS(I) : If GetAttr(IMAS) And FileAttribute.ReadOnly Then GoTo SLED
				L = FileLen(IMAS)
				If L < S Then
					VREM = Space(L) : N = 1
				Else
					VREM = Space(S) : N = CInt(1.01! * L / S)
				End If
				My.Computer.FileSystem.RenameFile(IMAS, FAIL)
				If Err.Number > 0 Then TXT = "Can't rename file " + IMAS : GoTo SLED
				FileOpen(1, FAIL, OpenMode.Binary, OpenAccess.Write)
				If Err.Number > 0 Then TXT = "Can't open file " + IMAS : GoTo SLED
				For M = 1 To N : FilePut(1, VREM) : Next M
				FileClose(1) : Kill(FAIL) : Console.Write(IMAS + vbCrLf)
SLED:
			Next I
			TXT = "Complete:" + Str$(H)
		End If
KON:
		Console.Write(vbCrLf + TXT + vbCrLf + vbCrLf + "Press <Enter> to exit" + vbCrLf) : S = Console.Read : End
	End Sub

End Module
